     ;** Assembler code for real-mode and protected-mode
     ;** INT 0xC interrupt handlers to support the INT 0xC
     ;** interrupt in both modes
     ;**
     .386
     ;**
     ;** The real-mode interrupt handler is in a 16-bit code
     ;** segment so that the assembler will generate the right
     ;** code.  We will copy this code down to a 16-bit segment
     ;** in low memory rather than executing it in place.
     ;**

;     MYGROUP GROUP _TEXTMY
;     ASSUME cs:MYGROUP, ds:MYGROUP, es:MYGROUP

     _TEXTMY SEGMENT PARA COMMON USE16
     ASSUME  cs:_TEXTMY, ds:_TEXTMY, es:_TEXTMY

     ORG 00000h

     PUBLIC COM_buf16_
     PUBLIC COM_irqHandler16_

     BUF_LEN EQU 30000d

COM_buf16_:
     port dw 0
     rpos dw 0
     rend dw 0
     receiveLock dw 0
     bytesReceived dd 0
     bytesReceived16 dd 0
     spos dw 0
     send dw 0
     sendLock dw 0
     bytesSent dd 0
     bytesSent16 dd 0

     r db BUF_LEN dup (0);
     s db BUF_LEN dup (0);

     port_ equ offset port-COM_buf16_
     rpos_ equ offset rpos-COM_buf16_
     rend_ equ offset rend-COM_buf16_
     spos_ equ offset spos-COM_buf16_
     send_ equ offset send-COM_buf16_
     bytesReceived_ equ offset bytesReceived-COM_buf16_
     bytesReceived16_ equ offset bytesReceived16-COM_buf16_
     bytesSent_ equ offset bytesSent-COM_buf16_
     bytesSent16_ equ offset bytesSent16-COM_buf16_
     sendLock_ equ offset sendLock-COM_buf16_
     receiveLock_ equ offset receiveLock-COM_buf16_
     r_ equ offset r-COM_buf16_
     s_ equ offset s-COM_buf16_

PRINT_AX MACRO
COMMENT !

LOCAL PA,PAC,PA2,PAC2,PA3,PAC3,PA4,PAC4
        push    ax
        push    bx

        xchg    ah,al
        ror     ah,4
        ror     al,4
        mov     bx,ax
        and     ax,0fh
        cmp     ax,10d
        jae     PA
        add     al,'0'
        jmp     PAC
PA:
        add     al,'A'-10d
PAC:
        mov     ah,30
        stosw
        shr     bx,4
        mov     ax,bx
        and     ax,0fh
        cmp     ax,10d
        jae     PA2
        add     al,'0'
        jmp     PAC2
PA2:
        add     al,'A'-10d
PAC2:
        mov     ah,30
        stosw
        shr     bx,4
        mov     ax,bx
        and     ax,0fh
        cmp     ax,10d
        jae     PA3
        add     al,'0'
        jmp     PAC3
PA3:
        add     al,'A'-10d
PAC3:
        mov     ah,30
        stosw
        shr     bx,4
        mov     ax,bx
        and     ax,0fh
        cmp     ax,10d
        jae     PA4
        add     al,'0'
        jmp     PAC4
PA4:
        add     al,'A'-10d
PAC4:
        mov     ah,30
        stosw
        add     di,10
        pop     bx
        pop     ax
;        int 3
!
                ENDM

COM_irqHandler16_:
     push       ax
     push       bx
     push       dx

     push       ds
     push       es

     mov        ax,cs
     mov        ds,ax

COMMENT !
     mov        ax,0b800h
     mov        es,ax
     mov        di,0
     mov        ah,31
     mov        cx,80*20
;     repne      stosw
     sub        di,320
     !

     mov        dx,ds:port_
     add        dx,2
     in         al,dx
     sub        dx,2

     cmp        al,4
     je         h_receive
     cmp        al,2
     je         h_send
     jmp        h_end
h_receive:
     in         al,dx

     mov        dx,ds:receiveLock_
     or         dx,dx
     jne        h_end

     mov        bx,ds:rpos_
     mov        ds:[r_+bx],al
     inc        bx
     cmp        bx,BUF_LEN
     jne        h_recEnd

     mov        bx,0
h_recEnd:
     mov        ds:rpos_,bx
     inc        dword ptr ds:[bytesReceived_]
     inc        dword ptr ds:[bytesReceived16_]
     jmp        h_end

h_send:
     mov        bx,ds:spos_
     cmp        bx,ds:send_
     jne        h_sendNew

     mov        ax,0
     mov        word ptr ds:[sendLock_],ax
     jmp        h_end

h_sendNew:
     mov        al,[s_+bx]
     out        dx,al
     inc        bx
     cmp        bx,BUF_LEN
     jne        h_sendEnd

     mov        bx,0
h_sendEnd:
     mov        word ptr ds:[spos_],bx

     mov        ax,1
     mov        word ptr ds:[sendLock_],ax

     inc        dword ptr ds:[bytesSent_]
     inc        dword ptr ds:[bytesSent16_]
     jmp        h_end

h_end:
     mov        al,020h
     out        20h,al

     pop        es
     pop        ds

     pop        dx
     pop        bx
     pop        ax
     iret

COM_buf16_end:

     db         64000 - (offset COM_buf16_end - offset COM_buf16_) dup (0)

     _TEXTMY ENDS

END ;COM_irqHandler16_
