
#include "keyb.h"
#include "svga.h"
#include "dith.h"
#include "mouse.h"
#include "tm.h"
#include "scroll.h"
#include "timer.h"
#include "joy.h"
#include "cd.h"
#include "lzw.h"
#include "com.h"
#include "ipxnet.h"
#include "win.h"

#include "mcb_.cpp"
#include "int23_.cpp"
#include "cgdkp_.cpp"

extern "C" int SVGA_init (void);

void CGDK_init (void)
{
  _atexit (CGDK_done);
  DPMI_init ();
  _minit ();
  TM_init ();
  SVGA_init ();
  SVGAC_init (SVGAC_DEFMAXCACHEDSPRITES);
  MIRC_init (MIRC_DEFMAXCACHEDSPRITES);
  SCROLL_init ();
  MIR_init (MIRL_MAXDEF_LAYER, MIR_MAXDEF_SIZE);
  MOUSE_init ();
  INT23_init ();
  DITH_init (0);
  CGDK_mainInit ();

  #ifndef __TURBOC__
    CD_init ();
    LZW_init ();
    COM_init ();
    JOY_init ();
//    NET_Init ();
  #endif
}

/*
void CGDK_initDebug (void)
{
  _atexit (CGDK_done);
  printf ("Calling DPMI_init ...\n");
  DPMI_init ();
  _minit ();
  printf ("Calling SVGA_init ...\n");
  SVGA_init ();
  printf ("Calling TM_init ...\n");
  TM_init ();
  printf ("Calling SVGAC_init ...\n");
  SVGAC_init (SVGAC_DEFMAXCACHEDSPRITES);
  printf ("Calling MIRC_init ...\n");
  MIRC_init (MIRC_DEFMAXCACHEDSPRITES);
  printf ("Calling SCROLL_init ...\n");
  SCROLL_init ();
  printf ("Calling MIR_init ...\n");
  MIR_init (MIRL_MAXDEF_LAYER, MIR_MAXDEF_SIZE);
  printf ("Calling MOUSE_init ...\n");
  MOUSE_init ();
  printf ("Calling INT23_init ...\n");
  INT23_init ();
  printf ("Calling DITH_init ...\n");
  DITH_init (0);
  printf ("Calling CGDK_mainInit ...\n");
  CGDK_mainInit ();

  #ifndef __TURBOC__
    printf ("Calling CD_init ...\n");
    CD_init ();
    printf ("Calling LZW_init ...\n");
    LZW_init ();
    printf ("Calling COM_init ...\n");
    COM_init ();
    printf ("Calling JOY_init ...\n");
    JOY_init ();
//    NET_Init ();
  #endif
}
*/

void CGDK_done (void)
{
  writeln ();
  SVGA_done ();
  MIR_done ();
  SCROLL_done ();
  MOUSE_done ();
  DITH_done ();
  MIRC_done ();
  TM_done ();
  KEYB_done ();
  TIMER_done ();

  #ifndef __TURBOC__
    LZW_done ();
    COM_done ();
    CD_done ();
//    NET_Done ();
    WIN_done ();
  #endif
}
