
#ifndef _LZW_H_
  #define _LZW_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  typedef struct
  {
    int next;
    int prev;
    int value;
    int index;
  } TLZW_phrase;

  typedef struct
  {
    long bytesRead;
    long bytesWritten;
    int (*getChar) (void);
    int (*putChar) (int);

    TLZW_phrase *phrase;
    int codeCount;
    int code;
    int finChar;
    int mode;
  } TLZW;

  extern int LZW_getCharError (void);
  extern int LZW_putCharError (int c);

  extern void LZW_run (TLZW *lzw);

  extern TLZW *LZW_new (void);
  extern void LZW_free (TLZW *lzw);
  extern void LZW_init (void);
  extern void LZW_done (void);
  extern void LZW_compressInit (TLZW *lzw);
  extern void LZW_uncompressInit (TLZW *lzw);

  #include "lzwm_.h"
  #include "lzwf_.h"

  #ifdef __cplusplus
  }
  #endif

#endif
