
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#include "mouse.h"
#include "spr.h"
#include "mir.h"
#include "tm.h"
#include "dpmi.h"
#include "cgdk.h"
#include "svga.h"
#include "csf.h"

#define MOUSE_INT 0x33
#define MOUSE_INIT 0
#define MOUSE_SHOWCURSOR 1
#define MOUSE_HIDECURSOR 2
#define MOUSE_SETPOS 4
#define MOUSE_SETHANDLER 0x0C
#define MOUSE_SETXRANGE 7
#define MOUSE_SETYRANGE 8
#define MOUSE_SETSENSITIVITY 0x0F
#define MOUSE_SETACCELERATION 0x13
#define MOUSE_MASKALL 0xFF

#ifdef __TURBOC__
  extern void far _loadds _saveregs click_handler (void);
#else
  extern void far _loadds click_handler (int max, int mbx, int mcx, int mdx,
                                  int msi, int mdi);
#endif

volatile TMOUSE_info MOUSE_info;
int MOUSE_installed;
int MOUSE_cursorEnabled;
TMIR *MOUSE_mir;

int MOUSE_maxX;
int MOUSE_maxY;
int MOUSE_minX;
int MOUSE_minY;

void MOUSE_updateCursor (void)
{
  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    if (SVGA_graph)
    {
      if (MOUSE_cursorEnabled)
      {
        MIR_update (MOUSE_mir, MOUSE_info.x, MOUSE_info.y);
      }
    }
  }
}

void MOUSE_showCursor (void)
{
  union REGS regs;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    MOUSE_cursorEnabled = 1;
    if (SVGA_graph)
    {
      MOUSE_info.move = 1;
      MOUSE_updateCursor ();
    }
    else
    {
      regs.x.eax = MOUSE_SHOWCURSOR;
      int386 (MOUSE_INT, &regs, &regs);
    }
  }
}

void MOUSE_hideCursor (void)
{
  union REGS regs;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    if (SVGA_graph)
    {
      MIR_restore (MOUSE_mir);
    }
    else
    {
      regs.x.eax = MOUSE_HIDECURSOR;
      int386 (MOUSE_INT, &regs, &regs);
    }
    MOUSE_cursorEnabled = 0;
  }
}

void MOUSE_setWindow (int XMin, int YMin, int XMax, int YMax)
{
  union REGS regs;

  MOUSE_minX = XMin;
  MOUSE_minY = YMin;
  MOUSE_maxX = XMax;
  MOUSE_maxY = YMax;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    regs.x.eax = MOUSE_SETXRANGE;
    if (SVGA_graph == 0)
    {
      XMin = 8*XMin;
      XMax = 8*XMax;

      YMin = 8*YMin;
      YMax = 8*YMax;
    }
    regs.x.ecx = XMin;
    regs.x.edx = XMax;
    int386 (MOUSE_INT, &regs, &regs);

    regs.x.eax = MOUSE_SETYRANGE;
    regs.x.ecx = YMin;
    regs.x.edx = YMax;
    int386 (MOUSE_INT, &regs, &regs);

  }
}


void MOUSE_setCursor (TCSF *SPR, int n)
{
  if (MOUSE_installed == MOUSE_INSTALLED)
  {
//    if (SVGA_graph)
    {
      if (SPR == NULL)
      {
        MOUSE_hideCursor ();
      }
      else
      {
        if ( (MOUSE_mir == NULL) ||
             (SPR->sizeX != MOUSE_mir->sizeX) ||
             (SPR->sizeY != MOUSE_mir->sizeY)
           )
        {
          MIR_delete (MOUSE_mir);
          MOUSE_mir = MIR_new ( CSF_raw (SPR,n),
                                      SPR->sizeX, SPR->sizeY,
                                      MIRL_max-1, MIR_TYPE_SHADENONE, NULL);
        }
        else
        {
          MIR_changeSpr (MOUSE_mir, CSF_raw (SPR,n) );
        }
      }
    }
  }
}

#pragma saveregs
static void _click_handler (int event,int buttonState,int x,int y,int xMickeys,
                     int yMickeys)
{
    int NewX; //= (x >> 3);
    int NewY; //= (y >> 3);

    NewX = x;
    NewY = y;

    if ((!SVGA_graph) && (TM_clength) && (TM_width))
    {
      NewX = (NewX)/TM_clength;
      NewY = (NewY)/TM_cwidth;
    }

    MOUSE_info.move        = 1;//((NewX != MOUSE_info.x) || (NewY != MOUSE_info.y));
    MOUSE_info.xUpdate     += NewX - MOUSE_info.x;
    MOUSE_info.yUpdate     += NewY - MOUSE_info.y;
    MOUSE_info.x           = NewX;
    MOUSE_info.y           = NewY;
    MOUSE_info.xMickeys    = xMickeys;
    MOUSE_info.yMickeys    = yMickeys;
    MOUSE_info.event       = event;
    *(int *)&MOUSE_info.buttons = buttonState;
}






void MOUSE_setPosition (int X, int Y)
{
  union REGS regs;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    // set MOUSE position
    regs.x.eax = MOUSE_SETPOS;
    if (SVGA_graph == 0)
    {
      X = 8*(80/SVGA_maxX)*X;
      Y = 8*Y;
    }
    regs.x.ecx = X;
    regs.x.edx = Y;
    int386 (MOUSE_INT, &regs, &regs);
  }

  MOUSE_info.move = 1;
  MOUSE_info.x = X;
  MOUSE_info.y = Y;
}

void MOUSE_setSensitivity (int Sens_X, int Sens_Y)
{
  union REGS regs;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    regs.x.eax = MOUSE_SETSENSITIVITY;
/*    if (SVGA_graph == 0)
    {
      Sens_X = 8*Sens_X;
      Sens_Y = 8*Sens_Y;
    } */
/*    else
    {
      regs.x.eax = 0x1A;
      regs.x.ebx = 8;
      regs.x.ecx = 16;
      regs.x.edx = 64;
      int386 (MOUSE_INT, &regs, &regs);
    } */
    regs.x.ecx = Sens_X;
    regs.x.edx = Sens_Y;
    int386 (MOUSE_INT, &regs, &regs);
  }
}

void MOUSE_install (void)
{
  // set default MOUSE cursor
  // MOUSE_SetDefaultCursor ();

//  MOUSE_reinit ();

  if (MOUSE_mir != NULL)
  {
    MIR_delete (MOUSE_mir);
    MOUSE_mir = NULL;
  }

  MOUSE_setWindow (0, 0, SVGA_maxX, SVGA_maxY);
  MOUSE_setPosition (SVGA_maxX/2, SVGA_maxY/2);
//  MOUSE_setSensitivity (8, 8);

  if (SVGA_graph)
  {
    MOUSE_setCursor (MOUSE_NO_CURSOR, 0);
  }
  else
  {
    MOUSE_hideCursor ();
  }

  // set MOUSE move status
  MOUSE_info.move = 1;
}




int MOUSE_init (void)
{
  union REGS regs = {0};
  struct SREGS sregs = {0};
  void (far *function_ptr)();

  if (MOUSE_installed == 0)
  {
    if ( (* ((long *) MK_DP (0, sizeof (long)*MOUSE_INT))) != 0)
    {
      // check for MOUSE driver
      regs.x.eax = MOUSE_INIT;
      int386 (MOUSE_INT, &regs, &regs);
      if (regs.x.eax == 0xFFFF)
      {
        MOUSE_installed = MOUSE_INSTALLED;

        // install MOUSE interrupt handler
        regs.x.eax = MOUSE_SETHANDLER;
        regs.x.ecx = MOUSE_MASKALL;
        function_ptr = ( void(far *)(void) ) click_handler;
        regs.x.edx = FP_OFF (function_ptr);
        sregs.es   = FP_SEG (function_ptr);
        int386x (MOUSE_INT, &regs, &regs, &sregs);

//        _atexit (MOUSE_done);
        return 0;
      }
    }
    MOUSE_installed = MOUSE_NOTINSTALLED;
    return -1;
  }
  return MOUSE_installed;
}


int MOUSE_event (void)
{
  int Event;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    Event = MOUSE_info.event;
    MOUSE_info.event = 0;
    return Event;
  }
  return 0;
}

void MOUSE_setAcceleration (int MickeysPerSecond)
{
  union REGS regs;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    regs.x.eax = MOUSE_SETACCELERATION;
    regs.x.edx = MickeysPerSecond;

    int386 (MOUSE_INT, &regs, &regs);
  }
}



void MOUSE_done (void)
{
  union REGS regs;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    MOUSE_setCursor (MOUSE_NO_CURSOR, 0);

    // check installation again (to clear watcher)
    regs.x.eax = MOUSE_INIT;
    int386 (MOUSE_INT, &regs, &regs);

    if (MOUSE_mir)
    {
      MIR_free (MOUSE_mir);
      MOUSE_mir = NULL;
    }

    MOUSE_installed = 0;
  }
}

#ifdef __TURBOC__
  void far _loadds _saveregs click_handler (void)
  {
    _click_handler (_AX,_BX,_CX,_DX,_SI,_DI);
  }
#else

  #pragma off (check_stack)
  void far _loadds click_handler (int max, int mbx, int mcx, int mdx,
                                  int msi, int mdi)
  {
  #pragma aux click_handler parm [EAX] [EBX] [ECX] [EDX] [ESI] [EDI]
    _click_handler (max,mbx,mcx,mdx,msi,mdi);
  }

#endif
