
#ifndef _MOUSE_H
#define _MOUSE_H

  #ifdef __cplusplus
  extern "C" {
  #endif

  #include <stdlib.h>
  #include "csf.h"
  #include "mir.h"

  #include "mousemu_.h"

  #define MOUSE_NO_CURSOR NULL
  #define MOUSE_INSTALLED 1
  #define MOUSE_NOTINSTALLED -1

  typedef struct
  {
    unsigned volatile int left : 1;
    unsigned volatile int right : 1;
    unsigned volatile int middle : 1;
    unsigned volatile int reserved : 13;
  } TMOUSE_buttons;

  typedef struct
  {
    volatile unsigned int event;
    volatile TMOUSE_buttons buttons;
    volatile int reserved;
    volatile int x;
    volatile int y;
    volatile int xUpdate;
    volatile int yUpdate;
    volatile int xMickeys;
    volatile int yMickeys;
    volatile int move;
  } TMOUSE_info;

  extern int MOUSE_minX;
  extern int MOUSE_minY;
  extern int MOUSE_maxX;
  extern int MOUSE_maxY;

  extern int MOUSE_installed;
  extern volatile TMOUSE_info MOUSE_info;
  extern int MOUSE_cursorEnabled;

  extern TMIR *MOUSE_mir;

  extern int MOUSE_init (void);
  extern void MOUSE_install (void);
  extern void MOUSE_done (void);

  extern void MOUSE_setPosition (int X, int Y);
  extern void MOUSE_setSensitivity (int Sens_X, int Sens_Y);
  extern void MOUSE_setAcceleration (int MickeysPerSecond);

  extern void MOUSE_showCursor (void);
  extern void MOUSE_hideCursor (void);
  extern void MOUSE_updateCursor (void);
  extern void MOUSE_setCursor (TCSF *SPR,int n); // = 0
  extern void MOUSE_setWindow (int Start_X, int Start_Y, int End_X, int End_Y);

  #ifdef __cplusplus
  }
  #endif

#endif
