
//#include <i86.h>
#include <stdlib.h>
#include <mem.h>

#include "svga.h"
//#include "vga.h"
#include "mouse.h"
#include "spr.h"
#include "pal.h"
#include "dpmi.h"
#include "cgdk.h"
#include "timer.h"
#include "vsb.h"
#include "lin.h"
#include "tm.h"
#include "csf.h"

#define VGA_TEXTSEG 0xB800
#define MDA_TEXTSEG 0xB000

static int TM_defCursorX;
static int TM_defCursorY;
static int TM_defCursorType;
static int TM_defVGA50Lines;
static int TM_defSizeX;
static int TM_defSizeY;
static int TM_defSize;
//static short TM_defSeg;
//static short TM_defMode;
static short *TM_defScreen;
static void *TM_defVESAStateSave;

//static char *SVGA_linearBuf;
int TM_length;
int TM_width;
int TM_clength;
int TM_cwidth;
int TM_csize;
//int TM_graph;
TCSF **TM_font;

static unsigned TM_offset;
static int TM_mouseCursor;

static TMIR *TM_cursorMir;
static TCSF *TM_cursorCSF;
static int TM_cursorCSFN;
static int TM_cursorFreq;

static int TM_cursorX;
static int TM_cursorY;

static int TM_defMouseCursorEnabled;

void TM_setCursor (TCSF *SPR, int n, int freq)
{
  if (SPR == NULL)
  {
    MIR_restore (TM_cursorMir);
    TM_cursorMir = NULL;
  }
  else
  {
    TM_cursorCSF = SPR;
    TM_cursorCSFN = n;
    if (freq)
      TM_cursorFreq = freq;

    if ( (TM_cursorMir == NULL) ||
         (SPR->sizeX != TM_cursorMir->sizeX) ||
         (SPR->sizeY != TM_cursorMir->sizeY)
       )
    {
      MIR_delete (TM_cursorMir);
      TM_cursorMir = MIR_new ( CSF_raw (SPR,n), SPR->sizeX, SPR->sizeY, 0, MIR_TYPE_SHADENONE, NULL);
    }
    else
    {
      MIR_changeSpr (TM_cursorMir, CSF_raw (SPR,n) );
    }
  }
}

/*
void TM_setCursorFreq (int freq)
{
  TM_cursorFreq = freq;
}
*/

void TM_getCursorPos (int *X, int *Y)
{
  union REGS r;

  if (!SVGA_graph)
  {
    r.h.bh = 0;
    r.h.ah = 3;
    int386 (VGA_INT, &r, &r);
    *X = r.h.dl;
    *Y = r.h.dh;
  }
}

int TM_getCursorType (void)
{
  union REGS r;

  if (!SVGA_graph)
  {
    r.h.bh = 0;
    r.h.ah = 3;
    int386 (VGA_INT, &r, &r);
    return (r.x.ecx);
  }
  else
  {
    return 0;
  }
}

void TM_setCursorPos (int X, int Y)
{
  union REGS r;

  if (!SVGA_graph)
  {
    r.h.bh = 0;
    r.h.dl = X;
    r.h.dh = Y;
    r.h.ah = 2;
    int386 (VGA_INT, &r, &r);
  }
  TM_cursorX = X;
  TM_cursorY = Y;
}

void TM_setCursorType (int Type)
{
  union REGS r;

  if (!SVGA_graph)
  {
    r.x.ecx = Type;
    r.h.ah = 1;
    int386 (VGA_INT, &r, &r);
  }
  else
  {
    if (Type == TM_NOCURSOR)
    {
      TM_setCursor (NULL, 0, 0);
    }
    else
    {
      TM_setCursor (TM_cursorCSF, TM_cursorCSFN, 0);
    }
  }
}

void TM_updateCursor (void)
{
  if (SVGA_graph)
  {
    if (TM_cursorMir)
    {
      if (TM_cursorFreq == 0)
      {
        TM_cursorFreq = TM_CURSORFREQ_DEF;
      }
      if ((TIMER_timeTotal % (2*TM_cursorFreq)) < TM_cursorFreq)
      {
        MIR_restore (TM_cursorMir);
      }
      else
      {
        MIR_update (TM_cursorMir, TM_cursorX*TM_clength, TM_cursorY*TM_cwidth);
      }
    }
  }
}


int TM_getVGA50Lines (void)
{
  REGS regs;

  regs.w.ax = 0x1130;
  regs.w.bx = 0;
  regs.w.dx = 0;
  int386 (VGA_INT,&regs,&regs);
  return (regs.h.dl == 49);
}

void TM_setVGA50Lines (void)
{
  REGS regs;

  regs.w.ax = 0x1112;
  regs.w.bx = 0;
  int386 (VGA_INT,&regs,&regs); // Restore 50 line mode
}

static short TM_getChar ()
{
  REGS regs;

  regs.h.ah = 0x08;
  int386 (VGA_INT,&regs,&regs);
  return regs.w.ax;
}

static void TM_putChar (unsigned short c)
{
  REGS regs;

  regs.h.ah = 0x09;
  regs.h.bh = 0;
  regs.h.al = los (c);
  regs.h.bl = his (c);
  regs.x.ecx = 1;
  int386 (VGA_INT, &regs, &regs);
}


/*
static short TM_getCharXY (int x, int y)
{
  TM_setCursorPos (x, y);
  return TM_getChar ();
}

static void TM_putCharXY (int x, int y, short c)
{
  TM_setCursorPos (x, y);
  TM_putChar (c);
}
*/

void TM_init (void)
{
  TM_done ();

  if (TM_font == NULL)
  {
    TM_font = (TCSF * *) _calloc (256, sizeof (TCSF *), "Not enough memory for text mode font array.\n");
  }
}


void TM_setup (void)
{
  int mc;
  int i,j;

  if ((!SVGA_graph) && (TM_defScreen == NULL))
  {
//    _atexit (TM_done);

    mc = MOUSE_cursorEnabled;
    if (mc)
      MOUSE_hideCursor ();

    TM_defVGA50Lines = TM_getVGA50Lines ();
    TM_defVESAStateSave = VGA_saveState (); // VESA

    TM_defSizeX = *(short *) MK_DP (0, 0x44A);
    TM_defSizeY = *(short *) MK_DP (0, 0x44C)/TM_defSizeX;
    TM_defSize = 2*TM_defSizeX*TM_defSizeY;

    if (TM_defSize && (((unsigned)TM_defSize) < (200L*200L)))
    {
      TM_defScreen = (short *) _alloc (TM_defSize);
      if (TM_defScreen == NULL)
      {
        CGDK_exit ("Not enough memory for saving text mode screen.\n", 0);
      }
    }
    else
    {
      TM_defSize = 0;
    }

    TM_getCursorPos (&TM_defCursorX, &TM_defCursorY);
    TM_defCursorType = TM_getCursorType ();
//    TM_setCursorType (TM_NOCURSOR);

    if (TM_defScreen)
      memcpy (TM_defScreen, SVGA_videoBuf, TM_defSize);

    if (mc)
      MOUSE_showCursor ();

    TM_defMouseCursorEnabled = mc;
  }
}

void TM_restore (void)
{
  int mc;

  if (TM_defScreen)
  {
    mc = MOUSE_cursorEnabled;
    if (mc)
      MOUSE_hideCursor ();

    SVGA_setDefaultMode ();

    if (TM_defVGA50Lines)
    {
      TM_setVGA50Lines ();
    }

    if (TM_defVESAStateSave)
    {
      VGA_restoreState (TM_defVESAStateSave); // VESA
      TM_defVESAStateSave = NULL;
    }

    memcpy (SVGA_videoBuf, TM_defScreen, TM_defSize);

    TM_setCursorType (TM_defCursorType);
    TM_setCursorPos (TM_defCursorX, TM_defCursorY);

    if (TM_defMouseCursorEnabled)
      MOUSE_showCursor ();

    _free (TM_defScreen);
    TM_defScreen = NULL;
  }
}

void TM_done (void)
{
  TM_restore ();

  if (TM_font)
  {
    _free (TM_font);
    TM_font = NULL;
  }

  TM_length = 0;
  TM_width = 0;
  TM_clength = 0;
  TM_cwidth = 0;
  TM_csize = 0;
}


int TM_install (void)
{
  char mc;

  if (SVGA_graph)
  {
    TM_clength = TM_font [0]->sizeX;
    TM_cwidth = TM_font [0]->sizeY;
    TM_csize = TM_clength * TM_cwidth;
    TM_length = SVGA_maxX / TM_clength;
    TM_width = SVGA_maxY / TM_cwidth;
    TM_offset = 0;
  }
  else
  {
    switch (SVGA_returnVideoMode ())
    {
      case VGA_40x25x16TM:
      case VGA_40x25x16TC:
      case VGA_80x25x16TM:
      case VGA_80x25x16TC:
      case VGA_80x25x10TM:
      {
        TM_length = SVGA_maxX;
        TM_width = SVGA_maxY;
        if (SVGA_maxX)
        {
          TM_clength = 8*(80/SVGA_maxX);
        }
        else
        {
          TM_clength = 8;
        }
        TM_cwidth = 8;
        break;
      }
      default:
      {
        TM_length = TM_width = 0;
        return 1;
      }
    }
  }
  return 0;
}

void TM_printChar (char c, unsigned char color, int x, int y, void *backGround)
{
  int i;

  if (!SVGA_graph)
  {
    i = 2*(x + y*TM_length);
    ((char *)SVGA_videoBuf) [i] = c;
    ((char *)SVGA_videoBuf) [i+1] = color;
  }
  else
  {
    if (TM_font [color] == NULL)
    {
      color = 0;
    }

    if (backGround)
    {
      memcpy (VSB_sbuf, backGround, TM_csize);
    }
    else
    {
      memset (VSB_sbuf, 1, TM_csize);
    }

    LIN_sprcpy (VSB_sbuf, CSF_char (TM_font [color], c), TM_csize);

    SVGAC_putWin (VSB_sbuf, x * TM_clength, y * TM_cwidth,
                      TM_clength, TM_cwidth, TM_clength);
  }
}



void TM_printBlock (short *buf, int x, int y, int len, int width, void **sprUpdateBuf)
{
  int i,j;
  short *dst;
  int dstSizeX;
  int bufSizeX;
  int off;
  int offset;
  int blen;
  int blsize;
  void *spr;
  unsigned vsbOffset;
  char color;
  char c;

  if (TM_offset == 0)
  {
    SVGA_update (1);
  }

  if (MOUSE_cursorEnabled)
  {
    if (SVGA_graph)
    {
      if (SPR_touch (x*TM_clength, y*TM_cwidth, (x + len) * TM_clength, (y + width) * TM_cwidth,
                    MOUSE_mir->x, MOUSE_mir->y,
                    MOUSE_mir->x + MOUSE_mir->sizeX,
                    MOUSE_mir->y + MOUSE_mir->sizeY))
      {
        TM_mouseCursor = 1;
        MOUSE_hideCursor ();
        SVGA_flush ();
      }
    }
    else
    {
      TM_mouseCursor = 1;
      MOUSE_hideCursor ();

    }

  }

  if (!SVGA_graph)
  {
    TM_offset++;
    dst = (short *)SVGA_videoBuf + x + y*TM_length;
    dstSizeX = 2*TM_length;
    bufSizeX = 2*len;

    for (j = 0; j < width; j++)
    {
      for (i = 0; i < len; i++)
      {
        if (buf [i])
        {
          dst [i] = buf [i];
        }
      }
      * (int *) &dst += dstSizeX;
      * (int *) &buf += bufSizeX;
    }
  }
  else
  {
    offset = 0;
    vsbOffset = TM_offset;
    blen = len * TM_clength;
    blsize = blen * TM_cwidth;

    for (j = 0; j < width; j++)
    {
      for (i = 0; i < len; i++)
      {
        spr = sprUpdateBuf [offset/2];

        c = ((char *) buf) [offset];
        offset++;
        color = ((char *)buf) [offset];
        offset++;

        if (c)
        {
          if (TM_font [color] == NULL)
          {
            color = 0;
          }

          if (spr)
          {
            LIN_movWin_ (VSB_sbuf+vsbOffset, blen, spr, TM_clength, TM_clength, TM_cwidth);
          }
          else
          {
            LIN_memset_ (VSB_sbuf+vsbOffset, blen, 1, TM_clength, TM_cwidth);
          }

          LIN_movSpr_ (VSB_sbuf+vsbOffset, blen, CSF_char (TM_font [color], c), TM_clength, TM_clength, TM_cwidth);
        }
        else
        {
          LIN_memset_ (VSB_sbuf+vsbOffset, blen, 1, TM_clength, TM_cwidth);
        }

        vsbOffset += TM_clength;
      }
      vsbOffset += blsize - blen;
    }

    SVGAC_putWin (VSB_sbuf+TM_offset,
                      x * TM_clength, y * TM_cwidth,
                      len * TM_clength, width * TM_cwidth, len * TM_clength);

    TM_offset = vsbOffset;
  }
}

void TM_flush (void)
{
  if (TM_offset)
  {
    if (TM_mouseCursor)
    {
      MOUSE_showCursor ();
    }

    SVGA_flush ();

    TM_offset = 0;
  }
}

void TM_setTextFont (char *charTable, unsigned char first, unsigned char count, char width)
{
  RMINFO rmi;
  void *buf;
  int size;

  REGS regs;
  SREGS sregs;

  size = count*width*8;
  buf = DPMI_alloc (size);
  if (buf == NULL)
  {
    CGDK_exit ("Not enough memory to allocate 16-bit buffer for text font character table.\n", EXIT_FAILURE);
  }
  memcpy (buf, charTable, size);

  memset (&rmi, 0, sizeof rmi);
  rmi.x.eax = 0x1100;
  rmi.x.edx = first;
  rmi.x.ecx = count;
  rmi.h.bh = width;
  rmi.h.bl = 0;
  rmi.x.es = DP_SEG (buf);
  rmi.x.ebp = DP_OFF (buf);
  DPMI_int (VGA_INT, &rmi);

  DPMI_free (buf);

  if (MOUSE_cursorEnabled)
    MOUSE_showCursor ();

}

void TM_setROMFont (void)
{
  VGA_switchVideoMode (SVGA_returnVideoMode ());
  if (MOUSE_cursorEnabled)
    MOUSE_showCursor ();
}
